CollationKeyAnalyzer (Lucene 10.5.1 common API)
Description: declaration: package: org.apache.lucene.collation, class: CollationKeyAnalyzer

Package org.apache.lucene.collation

# Class CollationKeyAnalyzer

java.lang.Object
org.apache.lucene.analysis.Analyzer
org.apache.lucene.collation.CollationKeyAnalyzer

All Implemented Interfaces:
  `Closeable`, `AutoCloseable`

public final class CollationKeyAnalyzer extends Analyzer
Configures `KeywordTokenizer` with `CollationAttributeFactory`.

Converts the token into its `CollationKey`, and then encodes the CollationKey directly to allow it to be stored as an index term.

WARNING: Make sure you use exactly the same Collator at index and query time -- CollationKeys are only comparable when produced by the same Collator. Since `RuleBasedCollator`s are not independently versioned, it is unsafe to search against stored CollationKeys unless the following are exactly the same (best practice is to store this information with the index and check that they remain the same at query time):

1. JVM vendor
2. JVM version, including patch version
3. The language (and country and variant, if specified) of the Locale used when constructing the collator via `Collator.getInstance(java.util.Locale)`.
4. The collation strength used - see `Collator.setStrength(int)`

The `ICUCollationKeyAnalyzer` in the analysis-icu package uses ICU4J's Collator, which makes its version available, thus allowing collation to be versioned independently from the JVM. ICUCollationKeyAnalyzer is also significantly faster and generates significantly shorter keys than CollationKeyAnalyzer. See http://site.icu-project.org/charts/collation-icu4j-sun for key generation timing and key length comparisons between ICU4J and java.text.Collator over several languages.

CollationKeys generated by java.text.Collators are not compatible with those those generated by ICU Collators. Specifically, if you use CollationKeyAnalyzer to generate index terms, do not use ICUCollationKeyAnalyzer on the query side, or vice versa.

Since:
  3.1

- ## Nested Class Summary

  ## Nested classes/interfaces inherited from class org.apache.lucene.analysis.Analyzer

  `Analyzer.ReuseStrategy, Analyzer.TokenStreamComponents`

- ## Field Summary

  ### Fields inherited from class org.apache.lucene.analysis.Analyzer

  `GLOBAL_REUSE_STRATEGY, PER_FIELD_REUSE_STRATEGY`

- ## Constructor Summary

  Constructors
  Constructor
  Description
  `CollationKeyAnalyzer(Collator collator)`
  Create a new CollationKeyAnalyzer, using the specified collator.

- ## Method Summary

  Modifier and Type
  Method
  Description
  `protected AttributeFactory`
  `attributeFactory(String fieldName)`
  `protected Analyzer.TokenStreamComponents`
  `createComponents(String fieldName)`

  ### Methods inherited from class org.apache.lucene.analysis.Analyzer

  `close, getOffsetGap, getPositionIncrementGap, getReuseStrategy, initReader, initReaderForNormalization, normalize, normalize, tokenStream, tokenStream`

  ### Methods inherited from class java.lang.Object

  `clone, equals, finalize, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

- ## Constructor Details

  - ### CollationKeyAnalyzer

    public CollationKeyAnalyzer(Collator collator)
    Create a new CollationKeyAnalyzer, using the specified collator.
    Parameters:
      `collator` - CollationKey generator

- ## Method Details

  - ### attributeFactory

    protected AttributeFactory attributeFactory(String fieldName)
    Overrides:
      `attributeFactory` in class `Analyzer`

  - ### createComponents

    protected Analyzer.TokenStreamComponents createComponents(String fieldName)
    Specified by:
      `createComponents` in class `Analyzer`